//
//  ViewController.swift
//  Calculator
//
//  Created by Luciano Bononi on 25/02/15.
//  Copyright (c) 2015 Luciano Bononi. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    
    @IBOutlet weak var display: UILabel!
    
    var userIsInTheMiddleOfTypingANumber : Bool = false
    
    var brain = CalculatorBrain()
    
    @IBAction func appendDigit(sender: UIButton) {
        let digit = sender.currentTitle!
        if userIsInTheMiddleOfTypingANumber {
           display.text = display.text! + digit
        } else {
            display.text = digit
            userIsInTheMiddleOfTypingANumber = true
        }
    }
    

    
    @IBAction func operate(sender: UIButton) {
        let operation = sender.currentTitle!
        if userIsInTheMiddleOfTypingANumber {
            enter()
        }
        if let operation = sender.currentTitle {
            if let result = brain.performOperation(operation) {
                displayValue = result
            } else {
                displayValue = 0
            }
//        switch operation {
//            case "×": performOperation( { $0 * $1 } )
//            case "÷": performOperation( { $1 / $0 } )
//            case "+": performOperation( { $0 + $1 } )
//            case "−": performOperation( { $1 - $0 } )
//            case "√": performOperation( { sqrt($0) } )
//        default: break
//        }
        }
    }
    
//    var operandStack = Array<Double>()
    
    @IBAction func enter() {
        userIsInTheMiddleOfTypingANumber = false
//        operandStack.append(displayValue)
//        println("operandStack = \(operandStack)")
        if let result = brain.pushOperand(displayValue) {
            displayValue = result
        } else {
            displayValue = 0
        }
    }
    
    var displayValue: Double {
        get {
            return NSNumberFormatter().numberFromString(display.text!)!.doubleValue
        }
        set {
            display.text = "\(newValue)"
            userIsInTheMiddleOfTypingANumber = false
        }
    }
    
//    func performOperation(operation: (Double, Double) -> Double ) {
//        if operandStack.count >= 2 {
//            displayValue = operation(operandStack.removeLast(), operandStack.removeLast())
//            enter()
//        }
//    }
//    
//    func performOperation(operation: Double -> Double ) {
//        if operandStack.count >= 1 {
//            displayValue = operation(operandStack.removeLast())
//            enter()
//        }
//    }
    
//    func multiply (op1: Double, op2: Double) -> Double {
//        return op1*op2
//    }
    

}

